/* 
	update:2018/07/16
	author:liting
*/

import React from 'react';
import $ from 'jquery/src/ajax';
import { Form, Button, Input, Select, Spin, Table, message, Modal, Tooltip, Switch, DatePicker } from 'antd';
import { orderType } from '@/dataDic';
import { getOrderType } from '@/tools.js';
import moment  from 'moment';
//主体
const Order = Form.create()(
	React.createClass({
		loadData(pageNo) {
			this.state.data = [];
			this.setState({
				loading: true,
				page: pageNo
			});
			$.ajax({
				method: 'get',
				dataType: 'json',
				crossDomain: false,
				url: globalConfig.context + '/portal/service/jtProject/list',
				data: {
					pageNo: pageNo || 1,
					pageSize: this.state.pagination.pageSize,
					number: this.state.numberSearch,
					type: this.state.typeSearch,
					entryName: this.state.entryNameSearch,
					companyName: this.state.companyNameSearch,
					start: this.state.releaseDate[0],
					end: this.state.releaseDate[1]
				},
				success: function(data) {
					let theArr = [];
					if (!data.data || !data.data.list) {
						if (data.error && data.error.length) {
							message.warning(data.error[0].message);
						}
					} else {
						for (let i = 0; i < data.data.list.length; i++) {
							let thisdata = data.data.list[i];
							theArr.push({
								key: i,
								id: thisdata.id,
								name: thisdata.name,
								number: thisdata.number,
								createTime: thisdata.createTime ? new Date(thisdata.createTime).toLocaleString() : ''
							});
						}
						this.state.pagination.current = data.data.pageNo;
						this.state.pagination.total = data.data.totalCount;
					}
					this.setState({
						dataSource: theArr,
						pagination: this.state.pagination
					});
				}.bind(this)
			}).always(
				function() {
					this.setState({
						loading: false
					});
				}.bind(this)
			);
		},
		getInitialState() {
			return {
				searchMore: true,
				selectedRowKeys: [],
				selectedRows: [],
				loading: false,
				releaseDate: [],
				pagination: {
					defaultCurrent: 1,
					defaultPageSize: 10,
					showQuickJumper: true,
					pageSize: 10,
					onChange: function(page) {
						this.loadData(page);
						this.setState({
							selectedRowKeys: []
						});
					}.bind(this),
					showTotal: function(total) {
						return '共' + total + '条数据';
					}
				},
				columns: [
					{
						title: '订单编号',
						dataIndex: 'name',
						key: 'bname'
					},
					{
						title: '订单类型',
						dataIndex: 'cname',
						key: 'cname',
						render: (text) => {
							return getOrderType(text);
						}
					},
					{
						title: '订单日期',
						dataIndex: 'superName',
						key: 'superName'
					},
					{
						title: '订单金额',
						dataIndex: 'price',
						key: 'price'
					},
					{
						title: '项目名称',
						dataIndex: 'memberPrice',
						key: 'memberPrice',
						render: (text) => {
							return (
								<Tooltip title={text}>
									{text && text.length > 6 ? text.substr(0, 6) + '...' : text}
								</Tooltip>
							);
						}
					},
					{
						title: '消费者',
						dataIndex: 'activityPrice',
						key: 'activityPrice',
						render: (text) => {
							return getOrderType(text);
						}
					},
					{
						title: '消费者联系人',
						dataIndex: 'activityFlag',
						key: 'activityFlag'
					},
					{
						title: '消费者联系方式',
						dataIndex: 'activityFlag1',
						key: 'activityFlag1'
					},
					{
						title: '服务商',
						dataIndex: 'activityFlag12',
						key: 'activityFlag12',
						render: (text) => {
							return (
								<Tooltip title={text}>
									{text && text.length > 6 ? text.substr(0, 6) + '...' : text}
								</Tooltip>
							);
						}
					},{
						title: '服务商联系人',
						dataIndex: 'activityFlag3',
						key: 'activityFlag3'
					},
					{
						title: '服务商联系方式',
						dataIndex: 'activityFlag41',
						key: 'activityFlag41'
					},
				],
				dataSource: []
			};
		},
		componentWillMount() {
			this.loadData();
		},
		detailes(recard) {
			this.setState({
				loading: true
			});
			$.ajax({
				method: 'get',
				dataType: 'json',
				crossDomain: false,
				url: globalConfig.context + '/api/user/jtBusiness/project/detail',
				data: {
					id: recard.id
				},
				success: function(data) {
					let thisData = data.data;
					if (!thisData) {
						if (data.error && data.error.length) {
							message.warning(data.error[0].message);
						}
						thisData = {};
					}
					this.setState({
						id: thisData.id,
						data: thisData,
						createTime: thisData.createTime ? new Date(thisData.createTime).toLocaleString() : ''
					});
				}.bind(this)
			}).always(
				function() {
					this.setState({
						loading: false
					});
				}.bind(this)
			);
		},
		//项目列表整行点击
		tableRowClick(record, index) {
			this.state.RowData = record;
			this.setState({
				editvisible: true
			});
			this.detailes(record);
		},
		edithandleCancel(e) {
			this.setState({
				editvisible: false
			});
		},
		search() {
			this.loadData();
		},
		//搜索部分的清零
		reset() {
			this.state.numberSearch = '';
			this.state.typeSearch = undefined;
			this.state.companyNameSearch = '';
			this.state.entryNameSearch = '';
			this.state.releaseDate = [];
			this.state.searchMore=true;
			this.loadData();
		},
		searchSwitch() {
			this.setState({
				searchMore: !this.state.searchMore
			});
		},
		render() {
			const FormItem = Form.Item;
			const rowSelection = {
				selectedRowKeys: this.state.selectedRowKeys,
				onChange: (selectedRowKeys, selectedRows) => {
					this.setState({
						selectedRows: selectedRows.slice(-1),
						selectedRowKeys: selectedRowKeys.slice(-1)
					});
				}
			};
			const { RangePicker } = DatePicker;
			const theData = this.state.data || {};
			return (
				<div className="user-content">
					<div className="content-title">
						<span>咨询单管理</span>
					</div>
					<div className="user-search">
						<Input
							placeholder="订单编号"
							style={{ width: '150px', marginRight: '10px', marginBottom: '10px' }}
							value={this.state.numberSearch}
							onChange={(e) => {
								this.setState({ numberSearch: e.target.value });
							}}
						/>
						<Select
							placeholder="订单类型"
							style={{ width: '200px', marginRight: '10px' }}
							value={this.state.typeSearch}
							onChange={(e) => {
								this.setState({ typeSearch: e });
							}}
						>
							{orderType.map(function(item) {
								return <Select.Option key={item.value}>{item.key}</Select.Option>;
							})}
						</Select>
						<Input
							placeholder="公司名称"
							style={{ width: '150px', marginRight: '10px', marginBottom: '10px' }}
							value={this.state.companyNameSearch}
							onChange={(e) => {
								this.setState({ companyNameSearch: e.target.value });
							}}
						/>
						<Input
							placeholder="项目名称"
							style={{ width: '150px', marginRight: '10px', marginBottom: '10px' }}
							value={this.state.entryNameSearch}
							onChange={(e) => {
								this.setState({ entryNameSearch: e.target.value });
							}}
						/>
						<Input
							style={{ width: 140, marginRight: 10 }}
							value={this.state.employerNameSearch}
							onChange={(e) => {
								this.setState({ employerNameSearch: e.target.value });
							}}
							placeholder="客户名称"
						/>
						<Button type="primary" onClick={this.search} style={{ marginRight: '10px' }}>
							搜索
						</Button>
						<Button onClick={this.reset} style={{ marginRight: '10px' }}>
							重置
						</Button>
						<span>
							更多搜索<Switch  checked={!this.state.searchMore} onChange={this.searchSwitch} />
						</span>
						<div className="search-more" style={this.state.searchMore ? { display: 'none' } : {}}>
							<span style={{ marginRight: 10 }}>发布时间 :</span>
							<RangePicker
								value={[
									this.state.releaseDate[0] ? moment(this.state.releaseDate[0]) : null,
									this.state.releaseDate[1] ? moment(this.state.releaseDate[1]) : null
								]}
								onChange={(data, dataString) => {
									this.setState({ releaseDate: dataString });
								}}
							/>
						</div>
					</div>
					<div className="patent-table">
						<Spin spinning={this.state.loading}>
							<Table
								columns={this.state.columns}
								dataSource={this.state.dataSource}
								rowSelection={rowSelection}
								pagination={this.state.pagination}
								onRowClick={this.tableRowClick}
							/>
						</Spin>
					</div>
					<div className="patent-desc">
						<Modal
							className="customeDetails"
							title="订单详情"
							width="1000px"
							visible={this.state.editvisible}
							onOk={this.edithandleCancel}
							onCancel={this.edithandleCancel}
							footer=""
						>
							<Form layout="horizontal" onSubmit={this.edithandleSubmit} id="demand-form">
								<Spin spinning={this.state.loading}>
									<div className="clearfix">
										<FormItem
											className="half-item"
											labelCol={{ span: 8 }}
											wrapperCol={{ span: 12 }}
											label="订单编号"
										>
											<span>{theData.name}</span>
										</FormItem>
										<FormItem
											className="half-item"
											labelCol={{ span: 8 }}
											wrapperCol={{ span: 12 }}
											label="订单类型"
										>
											<span>{getOrderType(theData.type)}</span>
										</FormItem>
									</div>
									<div className="clearfix">
										<FormItem
											className="half-item"
											labelCol={{ span: 8 }}
											wrapperCol={{ span: 12 }}
											label="订单日期"
										>
											<span>{this.state.createTime}</span>
										</FormItem>
										<FormItem
											className="half-item"
											labelCol={{ span: 8 }}
											wrapperCol={{ span: 12 }}
											label="订单金额"
										>
											<span>{theData.isHot ? theData.isHot + '万元' : ''}</span>
										</FormItem>
									</div>
									<div className="clearfix">
										<FormItem
											className="half-item"
											labelCol={{ span: 8 }}
											wrapperCol={{ span: 12 }}
											label="项目名称"
										>
											<span>{theData.name}</span>
										</FormItem>
									</div>
									<div className="clearfix">
										<FormItem
											className="half-item"
											labelCol={{ span: 8 }}
											wrapperCol={{ span: 12 }}
											label="买方名称"
										>
											<span>{theData.memberPrice1}</span>
										</FormItem>
										<FormItem
											className="half-item"
											labelCol={{ span: 8 }}
											wrapperCol={{ span: 12 }}
											label="卖方名称"
										>
											<span>{theData.activityFlag1}</span>
										</FormItem>
										<FormItem
											className="half-item"
											labelCol={{ span: 8 }}
											wrapperCol={{ span: 12 }}
											label="买方联系人"
										>
											<span>{theData.activityPrice}</span>
										</FormItem>
										<FormItem
											className="half-item"
											labelCol={{ span: 8 }}
											wrapperCol={{ span: 12 }}
											label="卖方联系人"
										>
											<span>{theData.offset}</span>
										</FormItem>
										<FormItem
											className="half-item"
											labelCol={{ span: 8 }}
											wrapperCol={{ span: 12 }}
											label="买方联系方式"
										>
											<span>{theData.memberPrice}</span>
										</FormItem>
										<FormItem
											className="half-item"
											labelCol={{ span: 8 }}
											wrapperCol={{ span: 12 }}
											label="卖方联系方式"
										>
											<span>{theData.activityFlag}</span>
										</FormItem>
									</div>
								</Spin>
							</Form>
						</Modal>
					</div>
				</div>
			);
		}
	})
);

export default Order;
